
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android 事件分发机制具体解释 / 憋错料</title>

    <meta name="description" content="Android 事件分发机制具体解释 很多其它内容请參照我的个人网站: http://stackvoid.com/ 网上非常多关于Android事件分发机制的解释,大多数描写叙述的都不够清晰,没有吧来龙去脉搞清晰,本文将带你从Touch事件产生到Touch事件被消费这一全过程作全面的剖析. 产生Touch事件 这部分牵扯到硬件和Linux内核部分:我们简单讲述一下这部分内容,假设有兴趣的话能够參考这篇文章. 传递Touch事件 触摸事件是由Linux内核的一个Input子系统来管理的(InputManager),Linux子系统会在">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Android 事件分发机制具体解释</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>很多其它内容请參照我的个人网站：&nbsp;<a href="http://stackvoid.com/" rel="external nofollow noreferrer">http://stackvoid.com/</a></strong></p>
<p>网上非常多关于Android事件分发机制的解释，大多数描写叙述的都不够清晰，没有吧来龙去脉搞清晰，本文将带你从Touch事件产生到Touch事件被消费这一全过程作全面的剖析。</p>
<h3>产生Touch事件</h3>
<p>这部分牵扯到硬件和Linux内核部分；我们简单讲述一下这部分内容，假设有兴趣的话能够參考<a href="http://stackoverflow.com/questions/3696103/android-pass-kernel-input-event-dev-input-event-to-java" rel="external nofollow noreferrer">这篇文章</a>。</p>
<h3>传递Touch事件</h3>
<p>触摸事件是由Linux内核的一个Input子系统来管理的(InputManager)，Linux子系统会在<code>/dev/input/</code>&nbsp;这个路径下创建硬件输入设备节点(这里的硬件设备就是我们的触摸屏了)。当手指触动触摸屏时，硬件设备通过设备节点像内核(事实上是InputManager管理)报告事件，<code>InputManager</code>&nbsp;经过处理将此事件传给<br />
 Android系统的一个系统Service：<code>WindowManagerService</code>&nbsp;。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc3RhY2t2b2lkLmNvbS9hbGJ1bS8yMDE0LTA5LTMwLWRldGFpbHMtZGlzcGF0Y2gtb25Ub3VjaC1FdmVudC1pbi1BbmRyb2lkLTAxLmdpZg==.jpg"></p>
<p><code>WindowManagerService</code>调用dispatchPointer()从存放WindowState的z-order顺序列表中找到能接收当前touch事件的<br />
 WindowState，通过IWindow代理将此消息发送到IWindow服务端(IWindow.Stub子类)，这个IWindow.Stub属于ViewRoot(这个类继承Handler，主要用于连接PhoneWindow和WindowManagerService)，所以事件就传到了ViewRoot.dispatchPointer()中.</p>
<p>我们来看一下ViewRoot的dispatchPointer方法：</p>
<pre><code>1 public void dispatchPointer(MotionEvent event, long eventTime,
2             boolean callWhenDone) {
3         Message msg = obtainMessage(DISPATCH_POINTER);
4         msg.obj = event;
5         msg.arg1 = callWhenDone ? 1 : 0;
6         sendMessageAtTime(msg, eventTime);
7     }</code></pre>
<p>dispatchPointer方法就是把这个事件封装成Message发送出去，在ViewRoot Handler的handleMessage中被处理，其调用了mView.dispatchTouchEvent方法(mView是一个PhoneWindow.DecorView对象)，PhoneWindow.DecorView继承FrameLayout(FrameLayout继承ViewGroup，ViewGroup继承自View),DecorView里的dispatchTouchEvent方法例如以下. 这里的Callback的cb事实上就是Activity的attach()方法里的设置回调。</p>
<pre><code> 1 //in file PhoneWindow.java
 2 public boolean dispatchTouchEvent(MotionEvent ev) {
 3             final Callback cb = getCallback();
 4             if (mEnableFaceDetection) {
 5                 int pointCount = ev.getPointerCount();
 6
 7                 switch (ev.getAction() &amp; MotionEvent.ACTION_MASK) {
 8                 case MotionEvent.ACTION_POINTER_DOWN:
 9
10          .......
11
12             return cb != null &amp;&amp; !isDestroyed() &amp;&amp; mFeatureId &lt; 0 ? cb.dispatchTouchEvent(ev)
13                     : super.dispatchTouchEvent(ev);
14         }
15 //in file Activity.java -&gt; attach()
16         mFragments.attachActivity(this, mContainer, null);
17         mWindow = PolicyManager.makeNewWindow(this);
18         mWindow.setCallback(this);//设置回调</code></pre>
<p>也就是说，正常情形下，当前的Activity就是这里的cb，即调用了Activity的dispatchTouchEvent方法。</p>
<p>以下来分析一下从Activity到各个子View的事件传递和处理过程。</p>
<p>首先先分析Activity的dispatchTouchEvent方法。</p>
<pre><code>1 public boolean dispatchTouchEvent(MotionEvent ev) {
2         if (ev.getAction() == MotionEvent.ACTION_DOWN) {
3             onUserInteraction();
4         }
5         if (getWindow().superDispatchTouchEvent(ev)) {
6             return true;
7         }
8         return onTouchEvent(ev);
9     }</code></pre>
<p>onUserInteraction() 是一个空方法，开发人员能够依据自己的需求覆写这种方法(这种方法在一个Touch事件的周期肯定会调用到的)。假设推断成立返回True，当前事件就不在传播下去了。 superDispatchTouchEvent(ev) 这种方法做了什么呢？ getWindow().superDispatchTouchEvent(ev) 也就是调用了<code>PhoneWindow.superDispatchTouchEvent</code>&nbsp;方法，而这种方法返回的是<br />
 mDecor.superDispatchTouchEvent(event)，在内部类 DecorView(上文中的mDecor) 的superDispatchTouchEvent 中调用super.dispatchTouchEvent(event)，而DecorView继承自ViewGroup(通过FrameLayout，FrameLayout没有dispatchTouchEvent)，终于调用的是ViewGroup的dispatchTouchEvent方法。</p>
<p>小结一下。Event事件是首先到了 PhoneWindow 的 DecorView 的 dispatchTouchEvent 方法，此方法通过 CallBack 调用了 Activity 的 dispatchTouchEvent 方法，在 Activity 这里，我们能够重写 Activity 的dispatchTouchEvent 方法阻断 touch事件的传播。接着在Activity里的dispatchTouchEvent 方法里，事件又再次传递到DecorView，DecorView通过调用父类(ViewGroup)的dispatchTouchEvent<br />
 将事件传给父类处理，也就是我们以下要分析的方法，这才进入网上大部分文章解说的touch事件传递流程。</p>
<p>为什么要从 PhoneWindow.DecorView 中 传到 Activity，然后在传回 PhoneWindow.DecorView 中呢？&nbsp;主要是为了方便在Activity中通过控制dispatchTouchEvent 来控制当前Activity 事件的分发， 下一篇关于数据埋点文章就应用了这个机制</p>
<p>OK，我们要重点分析的就是ViewGroup中的dispatchTouchEvent方法。</p>
<pre><code>  1 @Override
  2     public boolean dispatchTouchEvent(MotionEvent ev) {
  3             //......
  4
  5             // Check for interception.
  6             final boolean intercepted;//是否被拦截
  7             if (actionMasked == MotionEvent.ACTION_DOWN
  8                     || mFirstTouchTarget != null) {//Touch按下事件
  9                 final boolean disallowIntercept = (mGroupFlags &amp; FLAG_DISALLOW_INTERCEPT) != 0;
 10                 if (!disallowIntercept) {
 11                     intercepted = onInterceptTouchEvent(ev);//推断消息是否须要被viewGroup拦截，这种方法我们能够覆写，
 12                                             //覆写生效的前提是 disallowIntercept 为FALSE，否则写了也没用
 13                     ev.setAction(action); // restore action in case it was changed
 14                 } else {//不同意拦截
 15                     intercepted = false;
 16                 }
 17             } else {
 18                 // There are no touch targets and this action is not an initial down
 19                 // so this view group continues to intercept touches.
 20         //这个操作不是一開始down事件，我们把它置为TRUE，拦截之
 21                 intercepted = true;
 22             }
 23
 24             // Check for cancelation.
 25             final boolean canceled = resetCancelNextUpFlag(this)
 26                     || actionMasked == MotionEvent.ACTION_CANCEL;
 27
 28                 //.........
 29
 30                     final int childrenCount = mChildrenCount;//ViewGroup中子View的个数
 31                     if (newTouchTarget == null &amp;&amp; childrenCount != 0) {
 32                         final float x = ev.getX(actionIndex);//获取坐标，用来比对
 33                         final float y = ev.getY(actionIndex);
 34                         // Find a child that can receive the event.
 35                         // Scan children from front to back.
 36                         final View[] children = mChildren;//获取viewgroup全部的子view
 37
 38                         final boolean customOrder = isChildrenDrawingOrderEnabled();//子View的绘制顺序
 39                         ////从高到低遍历全部子View，找到能处理touch事件的child View
 40                         for (int i = childrenCount - 1; i &gt;= 0; i--) {
 41                             final int childIndex = customOrder ?
 42                                     getChildDrawingOrder(childrenCount, i) : i;//依据Order获取子view
 43                             final View child = children[childIndex];
 44                             //推断是不是我们须要的View
 45                             if (!canViewReceivePointerEvents(child)
 46                                     || !isTransformedTouchPointInView(x, y, child, null)) {
 47                                 continue;
 48                             }
 49
 50                             newTouchTarget = getTouchTarget(child);//从链表里找子view
 51                             if (newTouchTarget != null) {//找到子view
 52                                 // Child is already receiving touch within its bounds.
 53                                 // Give it the new pointer in addition to the ones it is handling.
 54                 //已经找到，循环结束，目标就是newTouchTarget
 55                                 newTouchTarget.pointerIdBits |= idBitsToAssign;
 56                                 break;
 57                             }
 58
 59                     //.......
 60                         }
 61                     }
 62                 }
 63             }
 64
 65             // Dispatch to touch targets.
 66             if (mFirstTouchTarget == null) {
 67                 // No touch targets so treat this as an ordinary view.
 68     /*dispatchTransformedTouchEvent方法中，假设child是null，那么就调用super.dispatchTouchEvent，
 69    *也就是ViewGroup的父类View的dispatchTouchEvent（假设我们在前面拦截了touch事件，那么就会这样处理），
 70    *假设不是null，则调用child.dispatchTouchEvent。
 71    **/
 72                 handled = dispatchTransformedTouchEvent(ev, canceled, null,
 73                         TouchTarget.ALL_POINTER_IDS);
 74             } else {
 75             //....
 76             }
 77         //........
 78         return handled;
 79     }
 80  /**
 81      * Transforms a motion event into the coordinate space of a particular child view,
 82      * filters out irrelevant pointer ids, and overrides its action if necessary.
 83      * If child is null, assumes the MotionEvent will be sent to this ViewGroup instead.
 84      */
 85     private boolean dispatchTransformedTouchEvent(MotionEvent event, boolean cancel,
 86             View child, int desiredPointerIdBits) {
 87         final boolean handled;
 88
 89         //……
 90
 91         // Perform any necessary transformations and dispatch.
 92         if (child == null) {
 93             handled = super.dispatchTouchEvent(transformedEvent);
 94         } else {
 95             //……
 96             handled = child.dispatchTouchEvent(transformedEvent);
 97         }
 98
 99         // Done.
100         //……
101         return handled;
102     }</code></pre>
<p>我们来总结一下 ViewGroup 的 dispatchTouchEvent 的调用过程。</p>
<ol>
<li>首先推断此 MotionEvent 是否能被拦截，假设是的话，能调用我们覆写 onInterceptTouchEvent来处理拦截到的事件；假设此方法返回TRUE，表示须要拦截，那么事件到此为止，就不会传递到子View中去。这里要注意，onInterceptTouchEvent 方法默认是返回FALSE。</li>
<li>若没有拦截此Event，首先找到此ViewGroup中全部的子View，通过方法 canViewReceivePointerEvents和isTransformedTouchPointInView，对每一个子View通过坐标(Event事件坐标和子View坐标比对)计算，找到坐标匹配的View。</li>
<li>调用dispatchTransformedTouchEvent方法，处理Event事件。</li>
</ol>

<pre><code> 1 //ViewGroup.java dispatchTransformedTouchEvent方法截取
 2         if (cancel || oldAction == MotionEvent.ACTION_CANCEL) {
 3             event.setAction(MotionEvent.ACTION_CANCEL);
 4             if (child == null) {//Event事件被截获，调用父类View的dispatchTouchEvent方法
 5                 handled = super.dispatchTouchEvent(event);
 6             } else {
 7                 handled = child.dispatchTouchEvent(event);//调用子View的dispatchTouchEvent方法
 8             }
 9             event.setAction(oldAction);
10             return handled;
11         }</code></pre>

<ol>
<li>如果这个子View是一个Button，会调用Button.dispatchTouchEvent 方法，Button和它的父类TextView都没有dispatchTouchEvent方法，仅仅能继续看父类View了，事实上终于调用的还是View.dispatchTouchEvent 方法。</li>
<li>我们继续分析View.dispatchTouchEvent 方法。mOnTouchListener 是OnTouchListener对象，由setOnTouchListener 方法设置；</li>
</ol>

<pre><code> 1 public boolean dispatchTouchEvent(MotionEvent event) {
 2         if (mInputEventConsistencyVerifier != null) {
 3             mInputEventConsistencyVerifier.onTouchEvent(event, 0);
 4         }
 5
 6         if (onFilterTouchEventForSecurity(event)) {
 7             //noinspection SimplifiableIfStatement
 8             ListenerInfo li = mListenerInfo;//View 内部类，管理一些listener
 9             if (li != null &amp;&amp; li.mOnTouchListener != null &amp;&amp; (mViewFlags &amp; ENABLED_MASK) == ENABLED
10                     &amp;&amp; li.mOnTouchListener.onTouch(this, event)) {
11                 return true;
12             }
13
14             if (onTouchEvent(event)) {
15                 return true;
16             }
17         }
18
19         if (mInputEventConsistencyVerifier != null) {
20             mInputEventConsistencyVerifier.onUnhandledEvent(event, 0);
21         }
22         return false;//没有消费掉，仅仅能返回false，让调用者来处理了。
23     }
24     /**
25      * Register a callback to be invoked when a touch event is sent to this view.
26      * @param l the touch listener to attach to this view
27      */
28     public void setOnTouchListener(OnTouchListener l) {
29         getListenerInfo().mOnTouchListener = l;
30     }</code></pre>
<p>若当前ListenerInfo 方法初始化而且 li.mOnTouchListener 的&#20540;不为空且ENABLE掩码为Enable，那么调用mOnTouchListener(this,event)方法。<code>boolean<br />
 onTouch(View v, MotionEvent event)</code>&nbsp;这种方法是在View的内部接口 OnTouchListener中的，是一个空方法，须要用户自己来实现。拿一个Button来举例；我们覆写的onTouch()方法在这里被调用。</p>
<pre><code>1 button.setOnTouchListener(new OnTouchListener() {
2             @Override
3             public boolean onTouch(View v, MotionEvent event) {
4               //实现自己的功能
5                 return true;
6             }
7         });</code></pre>

<ol>
<li>若onTouch方法返回true，则表示被消费，不会继续传递下去；返回false，表示时间还没被消费，继续传递到 onTouchEvent 这种方法里。</li>
</ol>

<pre><code> 1 public boolean onTouchEvent(MotionEvent event) {
 2         //……
 3         if (((viewFlags &amp; CLICKABLE) == CLICKABLE ||
 4                 (viewFlags &amp; LONG_CLICKABLE) == LONG_CLICKABLE)) {
 5             switch (event.getAction()) {
 6                 case MotionEvent.ACTION_UP:
 7                     //……
 8                     //假设没有触发长按事件，手指动作是up，则运行performClick()方法
 9                         if (!mHasPerformedLongPress) {
10                             // This is a tap, so remove the longpress check
11                             removeLongPressCallback();
12
13                             // Only perform take click actions if we were in the pressed state
14                             if (!focusTaken) {
15                                 // Use a Runnable and post this rather than calling
16                                 // performClick directly. This lets other visual state
17                                 // of the view update before click actions start.
18                                 //这里推断并去运行单击事件
19                                 if (mPerformClick == null) {
20                                     mPerformClick = new PerformClick();
21                                 }
22                                 if (!post(mPerformClick)) {
23                                     performClick();
24                                 }
25                             }
26                         }
27
28                     break;
29                 case MotionEvent.ACTION_DOWN:
30                         //……
31                         //是否触发长按事件是在这里推断的，详细细节我就不贴出来了
32                         checkForLongClick(0);
33                         //……
34                     break;
35                     //……
36             }
37             return true;
38         }
39
40         return false;
41     }</code></pre>
<p>若状态不是CLICKABLE，那么会直接跳过推断运行return false，这意味着兴许的touch事件不会再传递过来了。而大家注意看，仅仅要是CLICKABLE，那么不管case哪个节点，最后都是return true，这样就保证了兴许事件能够传递过来。 非常明显在onTouchEvent 方法里面，主要就是推断应该运行哪个操作，是长按还是单击，然后去运行相应的方法。我们看看假设是单击，运行的方法：</p>
<pre><code> 1 public boolean performClick() {
 2         //……
 3
 4         ListenerInfo li = mListenerInfo;
 5         if (li != null &amp;&amp; li.mOnClickListener != null) {
 6             //播放点击音效
 7             playSoundEffect(SoundEffectConstants.CLICK);
 8             //运行onClick方法
 9             li.mOnClickListener.onClick(this);
10             return true;
11         }
12
13         return false;
14     }</code></pre>
<p>事实上就是调用了我们OnClickListener里面的onClick方法。所以说，当onTouch() 和 onClick()都存在时候，肯定是先运行onTouch，之后再运行onClick；假设onTouch 把事件截获直接return true，那么 onClick 方法就不会运行了。 到这里，整个touch事件的传递过程我们就分析完了。</p>
<p><a href="http://stackvoid.com/details-dispatch-onTouch-Event-in-Android/" rel="external nofollow noreferrer">Touch事件一般调用过程总结</a></p>
<p>用户点击屏幕产生Touch(包含DOWN、UP、MOVE，本文分析的是DOWN)事件 -&gt; InputManager -&gt; WindowManagerService.dispatchPointer() -&gt; IWindow.Stub -&gt; ViewRoot.dispatchPointer() -&gt; PhoneWindow.DecorView.dispatchTouchEvent() -&gt; Activity.dispatchTouchEvent() -&gt; PhoneWindow.superDispatchTouchEvent<br />
 -&gt; PhoneWindow.DecorView.superDispatchTouchEvent -&gt; ViewGroup.dispatchTouchEvent() -&gt; ViewGroup.dispatchTransformedTouchEvent() -&gt; 子View.dispatchTouchEvent() -&gt; 子View.onTouch() -&gt; 子View.onTouchEvent() -&gt; 事件被消费结束</p>
<h3>实用的參考</h3>
<ol>
<li><a href="http://blog.csdn.net/stonecao/article/details/6759189" rel="external nofollow noreferrer">Android<br />
 FrameWork——Touch事件派发过程具体解释</a></li>
<li><a href="http://blog.csdn.net/windskier/article/details/6966264" rel="external nofollow noreferrer">android的窗体机制分析------事件处理</a></li>
<li><a href="http://blog.csdn.net/guolin_blog/article/details/9153747" rel="external nofollow noreferrer">Android事件分发机制全然解析，带你从源代码的角度彻底理解(下)</a></li>
</ol>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 12:36:29 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Android 事件分发机制具体解释的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RqBl5M.html" rel="bookmark">Android 事件分发机制详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				更多内容请参照我的个人站点: http://stackvoid.com/ 网上很多关于Android事件分发机制的解释,大多数描述的都不够清晰,没有吧来龙去脉搞清楚,本文将带你从Touch事件产生到Touch事件被消费这一全过程作全面的剖析. 产生Touch事件 这部分牵扯到硬件和Linux内核部分:我们简单讲述一下这部分内容,如果有兴趣的话可以参考这篇文章. 传递Touch事件 触摸事件是由Linux内核的一个Input子系统来管理的(InputManager),Linux子系统会在/dev/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/My5D6pM.html" rel="bookmark">图解 Android 事件分发机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首发原文:http://mp.weixin.qq.com/s?__biz=MzI0MjE3OTYwMg==&amp;mid=2649548149&amp;idx=1&amp;sn=709149df682c7d3a6e453c9ef0626a1f&amp;chksm=f1180e08c66f871eb2e7e39e057a5b090214fd71adcd98aa36b3d7fcecf77ad5d08138c50131#rd 在Android开发中,事件分发机制是一块Android比较重要的知识体系,了解并熟			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDdXawM.html" rel="bookmark">Android事件分发机制完全解析，带你从源码的角度彻底理解&lpar;上&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/guolin_blog/article/details/9097463 其实我一直准备写一篇关于Android事件分发机制的文章,从我的第一篇博客开始,就零零散散在好多地方使用到了Android事件分发的知识.也有好多朋友问过我各种问题,比如:onTouch和onTouchEvent有什么区别,又该如何使用?为什么给ListView引入了一个滑动菜单的功能,ListView就不能滚动了?为什么图片轮播器里的图片使用Button而不用Ima			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n5eJ7M.html" rel="bookmark">android 事件分发机制&lpar;图文详解&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Android开发中,事件分发机制是一块Android比较重要的知识体系,了解并熟悉整套的分发机制有助于更好的分析各种点击滑动失效问题,更好去扩展控件的事件功能和开发自定义控件,同时事件分发机制也是Android面试必问考点之一,如果你能把下面的一些事件分发图当场画出来肯定加分不少.废话不多说,总结一句:事件分发机制很重要. Android 事件分发流 关于Android 事件分发机制网上的博文很多,但是很多都是写个Demo然后贴一下输出的Log或者拿源码分析,然后一堆的注释和说明,如果用心的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k9ke74.html" rel="bookmark">&lbrack;转&rsqb;Android事件分发机制完全解析，带你从源码的角度彻底理解&lpar;上&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android事件分发机制 该篇文章出处:http://blog.csdn.net/guolin_blog/article/details/9097463 其实我一直准备写一篇关于Android事件分发机制的文章,从我的第一篇博客开始,就零零散散在好多地方使用到了Android事件分发的知识. 也有好多朋友问过我各种问题,比如:onTouch和onTouchEvent有什么区别,又该如何使用?为什么给ListView引入了一个滑动菜单的 功能,ListView就不能滚动了?为什么图片轮播器里的图			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGAw8V3.html" rel="bookmark">（转） Android事件分发机制完全解析，带你从源码的角度彻底理解&lpar;上&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/guolin_blog/article/details/9097463 其实我一直准备写一篇关于Android事件分发机制的文章,从我的第一篇博客开始,就零零散散在好多地方使用到了Android事件分发的知识.也有好多朋友问过我各种问题,比如:onTouch和onTouchEvent有什么区别,又该如何使用?为什么给ListView引入了一个滑动菜单的功能,ListView就不能滚动了?为什么图片轮播器里的图片使用Button而不用Ima			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4p8PNg4.html" rel="bookmark">【朝花夕拾】Android自定义View篇之（六）Android事件分发机制（中）从源码分析事件分发逻辑及经常遇到的一些&OpenCurlyDoubleQuote;诡异&rdquo;现象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 转载请注明,转自[https://www.cnblogs.com/andy-songwei/p/11039252.html]谢谢! 在上一篇文章[[朝花夕拾]Android自定义View篇之(五)Android事件分发机制(上)Touch三个重要方法的处理逻辑][下文简称(五),请先阅读完(五)再阅读本文],我们通过示例和log来分析了Android的事件分发机制.这些,我们只是看到了现象,如果要进一步了解事件分发机制,这是不够的,我们还需要透过现象看本质,去研究研究源码.本文将从源码(基			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/gMWEoG3.html" rel="bookmark">Android事件分发机制详解：史上最全面、最易懂</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Android事件分发机制是每个Android开发者必须了解的基础知识 网上有大量关于Android事件分发机制的文章,但存在一些问题:内容不全.思路不清晰.无源码分析.简单问题复杂化等等 今天,我将全面总结Android的事件分发机制,我能保证这是市面上的最全面.最清晰.最易懂的 本文秉着&quot;结论先行.详细分析在后&quot;的原则,即先让大家感性认识,再通过理性分析从而理解问题: 所以,请各位读者先记住结论,再往下继续看分析: 文章较长,阅读需要较长时间,建议收藏等充足时间再进行阅读 目			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dgjgzM.html" rel="bookmark">Android事件分发机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/chziroy/article/details/44401615 要理解Android事件分发机制,首先得了解几个概念,也算是总结,如果暂时看不懂也无妨,本文会讲解这几个问题. 1,点击屏幕,首先事件的传递从Activity的dispatchTouchEvent()方法开始. 2,关于Android事件分发机制,相关方法的方法有三个:onTouchEvent(),dispatchTouchEvent(),还有onInterceptTouc			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMmBoK0.html" rel="bookmark" class="title">坦克大战&lpar;版本2&period;5-版本2&period;9&rpar;</a>
					<div>
						版本2.5 功能:添加“血块”步骤:        1)添加blood类        2)添加必要的方法:eat方法等        3)让blood对象固定轨迹运动, 并在一定时间后消失 具体代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pvk8w0.html" rel="bookmark" class="title">Cross Platform Note&colon; STD C&plus;&plus; Preprocessor directives &amp;amp&semi; pre-defined macros</a>
					<div>
						ref: http://www.cplusplus.com/doc/tutorial/preprocessor/ concolusion: directives: #define #undef #in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Ygbkw4.html" rel="bookmark" class="title">链家笔试2</a>
					<div>
						把m升水倒入n个相同的杯子(假设容器足够大),允许有的容器是空的,共有多少种不同的倒法?(用k表示)5 1 1 和1 5 1 和1 1 5 是同一种倒法 输入: 第一行是测试数据的数目 x(0 &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pvJGV0.html" rel="bookmark" class="title">审计 6  SSRF和任意文件读取</a>
					<div>
						1 &lt;?php 2 error_reporting(0); 3 session_start(); 4 header(&quot;Content-type:image/jpeg&quot;); 5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My5K7eM.html" rel="bookmark" class="title">jmeter的参数化方法汇总</a>
					<div>
						一.User Defined Variable 1.添加的位置 Add-&gt;Config Element-&gt;User Defined Variable 2.使用 变量phone添加成功后,在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/388npn3.html" rel="bookmark" class="title">艺多不压身 -- 目录</a>
					<div>
						-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- - ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49r77bM.html" rel="bookmark" class="title">OC-类</a>
					<div>
						1.关于头文件 #include &lt;stdio.h&gt;     #import &lt;Foundation/Foundation.h&gt; 区别:#import指令导入更快更有效率.#i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aAPEq0.html" rel="bookmark" class="title">Linux基础知识1</a>
					<div>
						1常用快捷键 虚拟中端的切换:Ctrl+Alt+F2~F6切换到虚拟终端(Linux5中的虚拟终端是F1~ F7,而现今的Linux7.0的虚拟终端是F2~F6):Ctrl+Alt+F1切换到图形终端 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NamZ23.html" rel="bookmark" class="title">Swift：函数和闭包</a>
					<div>
						函数 函数是一个完成独立任务的代码块,Swift中的函数不仅可以像C语言中的函数一样有函数的参数和返回值,而且还支持嵌套,并且有函数参数默认值.可变参数等. 1 //定义一个函数,注意参数和返回值,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEvvLP0.html" rel="bookmark" class="title">失败多少次不要紧&comma; 人们只会记住你成功的那一次&lpar;转&rpar;</a>
					<div>
						本文链接 http://www.nowamagic.net/librarys/eight/posts/2683 文 / 程浩 我的家乡,曾经流行过一种游戏.那时,吃一包干脆面,里面会赠送一张圆形硬卡. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47m1By0.html" rel="bookmark" class="title">shell文本过滤编程（二）：awk之基础</a>
					<div>
						[版权声明:转载请保留出处:blog.csdn.net/gentleliu.Mail:shallnew at 163 dot com] 上一节说到了grep命令,grep命令主要用在获取符合规则的行信 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JYaLn3.html" rel="bookmark" class="title">Qt的版本历史</a>
					<div>
						发展史 Qt的第一个商业版本于1995年推出,随后Qt的发展就很快了,下面是Qt发展史上的一 些里程碑,从之前的Qt1.x开始到现在的Qt5.x. Qt1-3 版本 发布日期 1.40 10 July ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmAkDDM.html" rel="bookmark" class="title">华为路由器实现负载均衡和冗余备份</a>
					<div>
						路由器实现负载均衡: 如上图:AR1访问AR3时数据分流走AR2和AR4实现负载均衡 AR1配置: [Huawei-GigabitEthernet0/0/0]ip add 1.1.1.1 28 [Hu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Nq1Jy3.html" rel="bookmark" class="title">采用API实现的文件拖放</a>
					<div>
						借助API函数CallWindowProc,DragAcceptFiles,DragQueryFile,DragFinish同样可以实现文件从资源管理器EXPLORE到应用程序的拖放,另一种方法是采用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDr6a83.html" rel="bookmark" class="title">来自Gradle的hello world</a>
					<div>
						来自Gradle的hello world Android Studio使用Gradle 构建项目 为什么要用Gradle? Gradle是比较先进的构建系统,也是一个很好的构建工具,允许通过插件自定义 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mo5azw3.html" rel="bookmark" class="title">随机数，Math&period;random&lpar;&rpar;&semi;</a>
					<div>
						随机数最适合用来创建随机行为: Math.random()用来生成一个在0(包括0)到1(不包括1)之间的随机小数, 因此Math.random()可能返回0但绝不会返回1. 用Math.floor可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vjAKg3.html" rel="bookmark" class="title">hibernate版本引起的问题</a>
					<div>
						关于maven项目的开发,我个人最近遇到了一系列的问题,不过解决了不少,现在把自己的一些经验分享给大家,java.lang.ClassNotFoundException: play.db.jpa.JP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGAAQo3.html" rel="bookmark" class="title">HDU1287 破译密码</a>
					<div>
						问题链接:HDU1287 破译密码.基础训练级的题,用C语言编写程序. C语言中,异或运算符是&quot;^&quot;.对于源码a,加密字母x,密文字母v,根据题意满足:a^x=v,那么有a^x^x ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wB5WN0.html" rel="bookmark" class="title">2&period; linux系统组成</a>
					<div>
						内核.shell.文件系统.应用程序. GNU Bourne-Again SHell 用户 ||bash 终端相当于是bash的接口和工具 cat/etc/shells | bash-4.1.2-9. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Moo5pwM.html" rel="bookmark" class="title">银联支付接口常见问题</a>
					<div>
						1)       开发过程中,报157错误. 答:看下GATEID是不是写了0001,如果是的话,把0001删掉. 2)       网上支付后,点提交时,页面提示:标准数据域不能为空怎么办? 答:商 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
